SystemOrganization addCategory: #'Glamour-Tools'!

!GLMPresentation methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 13:19'!
viewNested

	| view |
	view := ROMondrianViewBuilder new.
	self viewNestedOn: view.
	^ view open setLabel: 'Nested'.! !

!GLMPresentation methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 00:50'!
viewNestedOn: view
	view shape label text: [:each | each class name removePrefix: 'GLM'].
	view node: self! !

Object subclass: #GLMBrowserTemplate
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMBrowserTemplate class methodsFor: 'opening' stamp: 'tg 12/29/2009 03:33'!
openOn: anEntity
	^ self new openOn: anEntity! !

!GLMBrowserTemplate class methodsFor: 'opening' stamp: 'tg 1/15/2010 23:46'!
startOn: anEntity
	^ self new startOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'accessing' stamp: 'tg 12/29/2009 03:41'!
browser
	^ browser ifNil: [self buildBrowser. browser]! !

!GLMBrowserTemplate methodsFor: 'building' stamp: 'tg 12/15/2009 13:54'!
buildBrowser
	^ self subclassResponsibility! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:30'!
openOn: anEntity
	^ self browser openOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 1/15/2010 23:31'!
startOn: anEntity
	^ self browser startOn: anEntity! !

GLMBrowserTemplate subclass: #GLMGlobalBrowserTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMGlobalBrowserTemplate class methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self new
		open! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
entity
	^ self subclassResponsibility! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self openOn: self entity! !

GLMBrowserTemplate subclass: #GLMScriptingEditorTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMScriptingEditorTemplate commentStamp: 'TudorGirba 12/28/2011 23:33' prior: 0!
GLMScriptingEditorTemplate offers a simple template for building scripting editors.

It offers basically three panes:
- one for the script
- one for the set of input variables
- one for the preview once you accept the script

A typical case is provided by the GLMMondrianEasel.

To open any of the subclasses, you need to provide an array of associations whose values represent the names of a variables and the values are the objects referred by these variables. These variables can then be used in the code of the script.!

GLMScriptingEditorTemplate subclass: #GLMEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMEditor commentStamp: 'TudorGirba 12/28/2011 23:33' prior: 0!
This is an Glamour-based editor for Glamour browsers.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMEditor methodsFor: 'private' stamp: 'TudorGirba 12/30/2013 07:59'!
createResultBrowserWithBindings: bindings andScript: script
	| context resultBrowser scriptedBrowser composer |
	composer := GLMCompositePresentation new.
	context := GLMDoItContext with: #composer -> composer withAll: bindings.
	[ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			self inform: e class name , ': ' , e messageText halt. 
			^ GLMWrapper new show: #text; startOn: e class name , ': ' , e messageText ].
	scriptedBrowser := composer first.
	resultBrowser := GLMTabulator new.
	resultBrowser column: #theOuterPane.
	resultBrowser transmit
		fromOutsideEntityPort;
		to: #theOuterPane;
		andShow: [ :a | a custom: scriptedBrowser ].	"this is a bit of a hack.
	we take the entity as specified in the script by taking it directly
	from the evaluated script browser.
	this is needed because right now the input entity is specified 
	in the same script with the browser"
	^ resultBrowser startOn: composer entity! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	^ {#composer -> GLMCompositePresentation new}! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 6/1/2012 20:13'!
defaultScriptDisplayIn: aTextPresentation
	^ aTextPresentation 
		display: 'composer';
		morphicAct: [:text | GLMBasicExamples open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 12/8/2012 14:30'!
defaultTitle
	^ 'Glamour Editor'! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 5/24/2012 17:20'!
resultIn: composite
	composite dynamic
		title: 'Preview';
		display: [ :bindings :script | self createResultBrowserWithBindings: bindings andScript: script ];
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first openTree ] 
			entitled: 'View browser tree';
		act: [:dynamic | dynamic cachedPresentation presentations first panes first presentations first explore ]
			icon: GLMUIThemeExtraIcons glamorousInspect
			entitled: 'Explore';
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first open ] 
			icon: GLMUIThemeExtraIcons glamorousSpawn
			entitled: 'Spawn browser'! !

GLMScriptingEditorTemplate subclass: #GLMRoassalEasel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMRoassalEasel commentStamp: '<historical>' prior: 0!
This browser offers a Glamour-based Roassal Easel.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 6/5/2012 17:10'!
defaultScriptBindings
	^ {#view -> ROMondrianViewBuilder new}! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:56'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'view';
		morphicAct: [:text | GLMRoassalExamplesBrowser open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 5/7/2012 10:18'!
defaultTitle
	^ 'Roassal Easel'! !

!GLMRoassalEasel methodsFor: 'private' stamp: 'AndreiChis 12/19/2013 15:58'!
"protocol: private"
evaluate: script in: context for: view
	| message |
	^ [ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			message := e class name , ': ' , e messageText.
			self inform: message.
			view shape label color: Color red lighter; withText .
			view node: message ]! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 6/5/2013 23:11'!
resultIn: a
	^ a roassal
		title: 'View';
		painting: [ :view :bindings :script | 
					| context |
					context := GLMDoItContext with: #view -> view withAll: bindings.
					self evaluate: script in: context for: view ]! !

!GLMScriptingEditorTemplate class methodsFor: 'instance creation' stamp: 'TudorGirba 6/1/2012 20:09'!
open
	^ self openOn: {}! !

!GLMScriptingEditorTemplate class methodsFor: 'instance creation' stamp: 'TudorGirba 1/4/2012 08:08'!
openOn: anArrayOfAssociations
	"To spawn an editor, provide an array of associations whose values represent the names of a variables and the values are the objects referred by these variables. These variables can then be used in the code of the script.
	For example: 
	GLMEditor openOn: {#variable1->'value1' . #variable2->'value2'}"
	^ super openOn: anArrayOfAssociations! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:05'!
buildBrowser
	browser := GLMTabulator new.
	self setTitleOf: browser.
	browser
		row: #result span: 2;
		row: [ :r | 
					r
						column: #script span: 3;
						column: #variables span: 2 ].
	browser transmit
		to: #script;
		andShow: [ :a | self scriptIn: a ].
	browser transmit
		to: #variables;
		andShow: [ :a | self variablesIn: a ].
	browser transmit
		to: #result;
		fromOutsidePort: #entity;
		from: #script;
		andShow: [ :a | self resultIn: a ].
	^ browser! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	"Override this method if you want to provide more bindings for your editor.
	Typically these bindings are related to the Facade that offers the entry point to the scripting API"
	^ {}! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptDisplayIn: aPresentation
	^ ''! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:06'!
defaultTitle
	^ 'Editor'! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 18:55'!
resultIn: a
	"Override this method to describe the presentation that should show the result
	of evaluating the script"
	self subclassResponsibility ! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 5/24/2012 18:16'!
scriptIn: a
	^ a smalltalkCode
		title: 'Script';
		variableBindings: [ :bindings | 
					| col |
					col := OrderedCollection withAll: bindings.
					col addAll: self defaultScriptBindings.
					col ];
		with: [:p | self defaultScriptDisplayIn: p ];
		populate: #selection
			icon: GLMUIThemeExtraIcons glamorousPlay
			on: $s
			entitled: 'Generate'
			with: [ :text | text text ]
	";	act: [:text | text text ] icon: GLMUIThemeExtraIcons glamorousAccept entitled: 'Install'"! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:05'!
setTitleOf:  b
	b title: self defaultTitle! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 11/15/2011 21:44'!
variablesIn: a
	^ a table
		selectionAct: [:t | t selection value inspect ] on: $i entitled: 'Inspect';
		selectionAct: [:t | t selection value explore ] on: $I entitled: 'Explore';		
		column: 'Variable' evaluated: [ :each | each key asString ];
		column: 'Value' evaluated: [ :each | each value asString contractTo: 20 ]! !

Object subclass: #GLMDoItContext
	instanceVariableNames: 'variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMDoItContext commentStamp: 'TudorGirba 8/24/2011 23:50' prior: 0!
This offers support for a do it context.

Example:
context := GLMContext withAll: {#a -> 1 . #b -> 2}.
Compiler new evaluate: 'a + b' in: context to: context!

!GLMDoItContext class methodsFor: 'instance creation' stamp: 'TudorGirba 8/25/2011 00:03'!
with: aBinding withAll: aCollectionOfBindings
	| col |
	col := OrderedCollection with: aBinding.
	col addAll: aCollectionOfBindings.
	^ self withAll: col! !

!GLMDoItContext class methodsFor: 'instance creation' stamp: 'TudorGirba 8/24/2011 23:48'!
withAll: aCollectionOfBindings
	^ self new variableBindings: (aCollectionOfBindings inject: Dictionary new into: [:dict :each | dict at: each key put: each value. dict])! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:36'!
bindingOf: aKey
	^ self variableBindings at: #aKey ifAbsent: [nil]! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 3/15/2013 21:27'!
method 
	^ GLMDoItContext >> #method! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:44'!
namedTempAt: index
	^ self variableBindings at: (self tempNames at: index)! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:43'!
tempNames
	^ self variableBindings keys asSortedCollection! !

!GLMDoItContext methodsFor: 'accessing' stamp: 'TudorGirba 8/24/2011 23:36'!
variableBindings
	^ variableBindings! !

!GLMDoItContext methodsFor: 'accessing' stamp: 'TudorGirba 8/24/2011 23:36'!
variableBindings: anObject
	variableBindings := anObject! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/27/2013 16:27'!
openTree
	| composer |
	composer := GLMCompositePresentation new.
	composer 
		act: [:b | b update] 
		icon: GLMUIThemeExtraIcons glamorousRefresh 
		entitled: 'Update'.
	composer tabulator with: [:t | 
		t column: #theOne.
		t transmit to: #theOne; andShow: [:a | 
			a roassal 
				updateOn: GLMTransmissionTriggered from: [ self announcer ];
				painting: [:view :b | self viewTreeOn: view ] ]].
	composer openOn: self! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'tg 5/18/2010 13:50'!
screenshot: aFilenameString on: anObject after: aBlock
	 
	| window |
	window := self openOn: anObject.
	aBlock glamourValue: self asGlamorousMultiValue.
	World doOneCycle.
	PNGReadWriter putForm: window imageForm onFileNamed: aFilenameString.
	^ window! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 13:31'!
umlClassWithTitle: umlName view: view nodes: aNodes forEach: aOneArgForEachBlock

	self 
		umlClassWithTitle: umlName 
		view: view 
		nodes: aNodes 
		forEachInstanceVariable: [:e | e]
		methods: aOneArgForEachBlock! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 13:33'!
umlClassWithTitle: umlName view: view nodes: aNodes 
forEachInstanceVariable: aOneArgForEachBlock1 methods: aOneArgForEachBlock2

	view shape rectangle color: Color white.
	view extensibleSizeWithPaddingGap: 0. 
	view nodes: aNodes forEach: [ :eachNode |
		view interaction 
				nodraggable;
				forward: ROAbstractMouseDragging;
				forward: ROMouseClick.
		view interaction popupText.
		view shape centeredLabel text: umlName.
		view node: eachNode.

		view interaction 
				nodraggable;
				forward: ROAbstractMouseDragging;
				forward: ROMouseClick.
		view shape rectangle.
		view nodes: (Array with: eachNode) forEach: aOneArgForEachBlock1.

		view interaction 
				nodraggable;
				forward: ROAbstractMouseDragging;
				forward: ROMouseClick.
		view shape rectangle color: Color white.
		view nodes: (Array with: eachNode) forEach: aOneArgForEachBlock2.
		
		view verticalLineLayout
				gapSize: 0;
				on: ROLayoutBegin
				do: [ :event | | maxWidth |
						maxWidth := event elements maxValue: #width. 
						event elements do: [ :eachElement | 
								eachElement width: maxWidth ] ];
				on: ROLayoutEnd
				do: [ :event | | strategy |
						strategy := ROFixedSizedParent new paddingGap: 0.
						event elements do: [ :eachElement |
								eachElement resizeStrategy: strategy ] ]
	].! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 12:20'!
viewAnnouncements
	| view |
	view := ROMondrianViewBuilder new.
	self viewAnnouncementsOn: view.
	^ view open setLabel: 'Announcements'! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 12:46'!
viewAnnouncementsOn: view
	view shape rectangle withoutBorder.
	view node: 'Glamour' forIt: [
		self viewTreeOn: view ].
	self umlClassWithTitle: #yourself view: view nodes: (Array with: 'Announced objects') forEach: [ :eachNode |
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPanes flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asSet.
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPresentations flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asIdentitySet.
		view verticalLineLayout ].
	
	view shape line 
			color: Color red twiceLighter;
			attachPoint: (ROHorizontalAttachPoint new).
	view edges: self pane withAllPanes from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view shape line 
			color: Color red twiceLighter;
			attachPoint: (ROHorizontalAttachPoint new).
	view edges: self pane withAllPresentations from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view horizontalLineLayout horizontalGap: 50! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 13:38'!
viewNestedOn: view

	self 
		umlClassWithTitle: #name 
		view: view 
		nodes: self panes 
		forEachInstanceVariable: [ :each |
			view interaction
					nodraggable;
					forward: ROAbstractMouseDragging.
			view shape label text: #name.
			view nodes: each ports.
			view verticalLineLayout gapSize: 2 ]
		methods: [ :each | 
			each presentations presentations do: [:eachPresentation | 
				eachPresentation viewNestedOn: view ].
			view verticalLineLayout gapSize: 2 ].
	view 
		edges: self transmissions 
		fromAll: #origins
		to: #destination! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 12:10'!
viewSketch

	| view |
	
	view := ROMondrianViewBuilder new.
	self viewSketchOn: view.
	^ view openWithStatusbar setLabel: 'Sketch'! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 12:18'!
viewSketchOn: view
	| simpleName viewBrowser allTransmissions inTransmission|
	simpleName := [ :each | (each class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	allTransmissions := (self withAllPresentations select: [ :each | each isKindOf: GLMBrowser ]) flatCollect: #transmissions.
	inTransmission := [:port | allTransmissions anySatisfy: [:tr | (tr origins includes: port) or: [tr destination = port]]].
	viewBrowser := [ :browser | 
		self umlClassWithTitle: simpleName view: view nodes: (Array with: browser) forEach: [ :each |
			view interaction
					nodraggable;
					forward: ROAbstractMouseDragging.
			view
				nodes: browser panes
				forEach: [ :inPane | 
					view interaction
							nodraggable;
							forward: ROAbstractMouseDragging.
					view nodes: (inPane ports select: inTransmission).
					view interaction
							nodraggable;
							forward: ROAbstractMouseDragging.
					view shape label text: simpleName.
					view
						nodes: inPane presentations presentations
						forEach: [ :inPresentation | 
							(inPresentation isKindOf: GLMBrowser)
								ifTrue: [ viewBrowser value: inPresentation ] ] ].
			((browser isKindOf: GLMTabulator) and: [ browser cell isSplitIntoRows ])
				ifTrue: [ view verticalLineLayout gapSize: 2 ] ] ].
	viewBrowser value: self.
	view shape line color: Color blue.
	view edges: allTransmissions fromAll: #origins to: #destination! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/27/2013 16:27'!
viewTree

	| view |
	
	view := ROMondrianViewBuilder new.
	self viewTreeOn: view.
	^ view openWithStatusbar setLabel: 'Tree'! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/28/2013 12:07'!
viewTreeOn: view
	| edges1 edges2 edges3 edges4 |
	
	self umlClassWithTitle: #name view: view nodes: self pane withAllPanes forEach: [ :each |
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: #name.
		view nodes: each ports.
		view verticalLineLayout gapSize: 2 ].

	view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	view nodes: self pane withAllPresentations.

	view shape orthoVerticalLine color: Color lightGray. 	
	edges1 := view edges: self pane withAllPanes from: #yourself to: [:each | each presentations ].

	view shape orthoVerticalLine color: Color lightGray. 
	edges2 := view edges: self pane withAllPanes from: #browser to: #yourself.

	view shape orthoVerticalLine color: Color lightGray. 
	edges3 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation]) from: #yourself to: #cachedPresentation.

	view shape orthoVerticalLine color: Color lightGray.
	edges4 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation]) from: #yourself toAll: #presentations.


	view treeLayout layered userDefinedEdges: (edges1, edges2, edges3, edges4).

	view shape line color: Color blue. 
	view 
		edges: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		fromAll: #origins
		to: #destination.
		view shape line color: Color blue
! !
